package org.freecompany.imp;

import java.net.URL;
import java.net.URLClassLoader;
import java.util.logging.Logger;
import org.apache.tools.ant.BuildException;
import org.freecompany.brimstone.module.DelegatingClassLoader;

import static java.util.logging.Level.FINE;

public class Load extends Resolve {

	protected final Logger logger = Logger.getLogger( Load.class.getName());

	public void execute() throws BuildException {
		super.execute();
		final ClassLoader loader = getClass().getClassLoader();
		if ( loader instanceof DelegatingClassLoader) {
			logger.log( FINE, "Adding {0} to the current classloader delegates.", url);
			(( DelegatingClassLoader) loader).addUrl( url);

		} else logger.log( FINE, "Current classloader type {0}, not running under Brimstone.", loader.getClass());
	}

	public String toString() {
		return "Load[ " + url + "]";
	}
}
