package org.freecompany.imp;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.Property;

import static org.apache.tools.ant.Project.*;

public class PropertyTask extends Property {

	/**
	 * Does nothing when called in document order by the Ant
	 * runtime.
	 */
	public void execute() throws BuildException {
		log( "Registering property '" + name + "' for alter execution.", MSG_DEBUG);
		Util.getProperties( getProject()).add( this);
	}

	/**
	 * Delegates to the superclass execute when we run it at
	 * the appropriate time, which is after the {@link Index} has
	 * processed imports and set the core properties.  This allows
	 * properties within this one to be properly expanded regardless
	 * of where in the build file or set of imports this property
	 * appears.
	 */
	public void executeNow() throws BuildException {
		log( "Setting property '" + name + "'.", MSG_DEBUG);
		super.execute();
	}
}
