package org.freecompany.imp;

import java.net.URI;
import org.apache.tools.ant.*;
import org.apache.tools.ant.types.*;

public class Repository extends Task {

	protected URI base;

	/**
	 * Sets up a locally defined repository in the build file.  These are handled through the
	 * URI resolver abstraction class, {@link Access}, which handles configuring and calling the backing
	 * resolution system.
	 */
	public void execute() {
		log( "Adding repository '" + base + "'.");
		Access.addRepository( base);
	}

	public void setBase( URI base) {
		this.base = base;
	}

	public URI getBase() {
		return base;
	}
}
