package org.freecompany.imp;

import org.freecompany.infoset.Infoset;
/*
import org.freecompany.pipeline.Context;
import org.freecompany.pipeline.Pipeline;
import org.freecompany.pipeline.impl.BasicPipeline;
import org.freecompany.pipeline.impl.BasicContext;
import org.freecompany.pipeline.impl.processors.TransformerProcessor;
import org.freecompany.pipeline.impl.processors.PersistenceProcessor;
*/
import java.io.File;
import java.util.ArrayList;
import java.util.UUID;
import java.util.List;
import java.util.logging.Logger;
import javax.xml.parsers.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.types.*;
import org.w3c.dom.Document;
import org.xml.sax.*;

import static java.util.logging.Level.*;
import static org.apache.tools.ant.Project.*;
import static org.freecompany.imp.Constants.*;
import static org.freecompany.infoset.InfosetFactory.Registry.lookup;

public class Transform extends Task {

	protected final Logger logger = Logger.getLogger( Transform.class.getName());
	protected final List< Style> styles = new ArrayList< Style>();
	protected final List< Parameter> parameters = new ArrayList< Parameter>();
	
	protected String type;
	protected File todir;
	protected FileSet fileset;

	public void execute() throws BuildException {
		/*
		try {
			final Pipeline pipeline = new BasicPipeline();
			for ( Parameter parameter : parameters) pipeline.setParameter( parameter.getName(), parameter.getValue());

			final DirectoryScanner scanner = fileset.getDirectoryScanner( getProject());
			final File base = scanner.getBasedir();

			UUID uuid = null;
			for ( Style style : styles) {
				log( "Loading stylesheet '" + style.getUrl() + "'.", MSG_DEBUG);
				Context transformer = new BasicContext();
				transformer.setProcessor( new TransformerProcessor());
				transformer.setInput( "source", lookup( Document.class).create( style.getUrl()));
				transformer.addInput( "document", "#" + (uuid == null ? "document" : uuid.toString()));
				for ( Parameter parameter : style.getParameters()) transformer.setParameter( parameter.getName(), parameter.getValue());
				transformer.setPipeline( pipeline);
				uuid = UUID.randomUUID();
				transformer.addOutput( "#" + uuid, "result");
				pipeline.addProcessor( transformer);
			}

			Context persistence = new BasicContext();
			persistence.setProcessor( new PersistenceProcessor());
			persistence.addInput( "document", "#" + (uuid == null ? "document" : uuid.toString()));
			persistence.addOutput( "#result", "result");
			persistence.setPipeline( pipeline);
			pipeline.addProcessor( persistence);

			Infoset< ?> document;
			String dir, root;
			for ( String file : scanner.getIncludedFiles()) {
				File target = new File( base, file);
				document = lookup( Document.class).create( target.toURL());
				pipeline.setInput( "#document", document);
				pipeline.setParameter( "directory", target.getParentFile().getAbsolutePath());

				dir = buildPath( file);
				root = buildRoot( file);
				log( "Found base dir '" + dir + "' and root dir '" + root + "'.", MSG_DEBUG);
				
				pipeline.setParameter( "base", dir);
				pipeline.setParameter( "root", root);

				String renamed = file.replaceFirst( "[.]\\w*", "." + type);
				log( "Transforming '" + file + "' to '" + renamed + "'.");

				File destination = new File( todir, renamed);
				destination.getParentFile().mkdirs();
				persistence.setParameter( "destination", destination.getAbsolutePath());
				log( "Persistence destination set to '" + destination.getAbsolutePath() + "'.", MSG_DEBUG);

				log( "Final infoset was '" + pipeline.process( "#result").get() + "'.", MSG_DEBUG);
			}
		} catch ( Exception e) {
			throw new BuildException( e);
		}
		*/
	}

	public void addParameter( final Parameter parameter) {
		parameters.add( parameter);
	}

	public void setType( String type) {
		this.type = type;
	}

	public void setTodir( File todir) {
		this.todir = todir;
	}

	public void addFileset( FileSet fileset) throws BuildException {
		if ( this.fileset != null) throw new BuildException( "The fileset is already set.");
		this.fileset = fileset;
	}

	public void addStyle( Style style) {
		styles.add( style);
	}

	protected static String buildPath( String path) {
		int index = path.lastIndexOf( "/");
		if ( index != -1) return path.substring( 0, index);
		return "";
	}

	protected static String buildRoot( String path) {
		StringBuffer buffer = new StringBuffer();
		int index;
		while (( index = path.indexOf( "/")) != -1) {
			buffer.append( "../");
			path = path.substring( index + 1);
		}
		return buffer.toString();
	}
}
