package org.freecompany.imp;

import java.util.List;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.taskdefs.optional.XMLValidateTask;

import static org.apache.tools.ant.Project.MSG_DEBUG;

public class XmlValidate extends XMLValidateTask {

	/**
	 * Checks provided filesets fo contents, and returns immediately
	 * if there are no matched files to eliminate verbose output.
	 */
	@SuppressWarnings( "unchecked")
	public void execute() throws BuildException {
		boolean exit = true;
		for ( FileSet fileset : ( List< FileSet>) filesets) {
      exit &= fileset.getDirectoryScanner( getProject()).getIncludedFiles().length == 0;
    }
		if ( exit) {
      log( "No files found for validation, skipping.", MSG_DEBUG);
      return;
    }
		super.execute();
	}
}
